#ifndef TrackableApiEtsi_H_
#define TrackableApiEtsi_H_



#include <pistache/endpoint.h>
#include <pistache/http.h>
#include <pistache/router.h>
#include <memory>
#include <optional>
#include <WorldStorageManager.h>
#include <TrackablesApi.h>

namespace etsi
{
using namespace org::openapitools::server::model;

class TrackableApiEtsi : public org::openapitools::server::api::TrackablesApi {
public:
    explicit TrackableApiEtsi(const std::shared_ptr<Pistache::Rest::Router>& rtr);
    ~TrackableApiEtsi() override = default;

    void add_trackable(const Trackable &trackable, Pistache::Http::ResponseWriter &response);
    void delete_trackable(const std::string &trackableId, Pistache::Http::ResponseWriter &response);
    void get_trackable_by_id(const std::string &trackableId, Pistache::Http::ResponseWriter &response);
    void get_trackables(Pistache::Http::ResponseWriter &response);
    
private:
    WorldStorageManager *m_manager;
};
}

#endif
